/**
 * @file
 *
 * References.
 *
 * @author Lawrence Murray <lawrence.murray@csiro.au>
 */

/**
 * @page references References
 *
 * @section references References
 *
 * @anchor Andrieu2010
 * Andrieu, C.; Doucet, A. & Holenstein, R. Particle Markov chain Monte Carlo
 * methods. <i>Journal of the Royal Statistical Society B</i>,
 * <b>2010</b>, 72, 269-302.
 *
 * @anchor Bentley1979
 * Bentley, J. L. & Saxe, J. B. Generating sorted lists of random numbers.
 * <i>Carnegie Mellon University</i>, <b>1979</b>.
 *
 * @anchor Chopin2013
 * Chopin, N.; Jacob, P. & Papaspiliopoulos, O. SMC\f$^2\f$: An Efficient
 * Algorithm for Sequential Analysis of State Space Models. <i>Journal of the
 * Royal Statistical Society B</b>, <b>2013</b>, 75, 397-426.
 *
 * @anchor DelMoral2014
 * Del Moral, P. & Murray L. M. Sequential Monte Carlo with highly informative
 * observations. <b>2014</b>. http://arxiv.org/abs/1405.4081.
 *
 * @anchor Gray2001
 * Gray, A. G. & Moore, A. W. `N-Body' Problems in Statistical
 * Learning. <i>Advances in Neural Information Processing Systems</i>,
 * <b>2001</b>, <i>13</i>.
 *
 * @anchor Haario2001
 * Haario, H.; Saksman, E. & Tamminen, J. An adaptive Metropolis algorithm.
 * <i>Bernoulli</i>, <b>2001</b>, 7, 223-242.
 *
 * @anchor Hairer1993
 * Hairer, E.; Norsett, S. N. & Wanner, G. Solving Ordinary Differential
 * Equations I: Nonstiff Problems. Springer-Verlag, <b>1993</b>.
 *
 * @anchor Jones2010
 * Jones, E.; Parslow, J. & Murray, L. A Bayesian approach to state and
 * parameter estimation in a Phytoplankton-Zooplankton model. <i>Australian
 * Meteorological and Oceanographic Journal</i>, <b>2010</b>, 59, 7-16.
 *
 * @anchor Kennedy2000
 * Kennedy, C. A.; Carpenter, M. H. & Lewis, R. M. Low-storage, explicit
 * Runge-Kutta schemes for the compressible Navier-Stokes equations.
 * <i>Applied Numerical Mathematics</i>, <b>2000</b>, 35, 177-219
 *
 * @anchor Kitagawa1996
 * Kitagawa, G. Monte Carlo %Filter and %Smoother for Non-Gaussian
 * Nonlinear %State Space Models. <i>Journal of Computational and
 * Graphical Statistics</i>, <b>1996</b>, 5, 1-25.
 *
 * @anchor Marsaglia2000
 * Marsaglia, G. & Tsang, W. W. A Simple Method for Generating Gamma
 * Variables. <i>ACM Transactions on Mathematical Software</i>, <b>2000</b>,
 * 26, 363-372.
 *
 * @anchor Murray2011
 * Murray, L.M. GPU acceleration of Runge-Kutta integrators. <i>IEEE
 * Transactions on Parallel and Distributed Systems</i>, <b>2011</b>, to
 * appear.
 *
 * @anchor Murray2011a
 * Murray, L.M. GPU acceleration of the particle filter: The Metropolis
 * resampler. <i>DMMD: Distributed machine learning and sparse representation
 * with massive data sets</i>, <b>2011</b>.
 *
 * @anchor Murray2011b
 * Murray, L.M. & Storkey, A. Particle smoothing in continuous time: A fast
 * approach via density estimation. <i>IEEE Transactions on Signal
 * Processing</i>, <b>2011</b>, 59, 1017-1026.
 *
 * @anchor Murray2013
 * Murray, L. M.; Jones, E. M. & Parslow, J. On Disturbance State-Space Models
 * and the Particle Marginal Metropolis-Hastings Sampler. <i>SIAM/ASA Journal
 * of Uncertainty Quantification</i>, <b>2013</b>, 1, 494-521.
 *
 * @anchor Murray2014
 * Murray, L. M.; Lee, A & Jacob P. E. Parallel resampling in the particle
 * filter. <b>2014</b>. http://arxiv.org/abs/1301.4019.
 *
 * @anchor Pitt1999
 * Pitt, M. & Shephard, N. Filtering Via Simulation: Auxiliary Particle
 * Filters. <i>Journal of the American Statistical Association</i>,
 * <b>1999</b>, 94, 590-599.
 *
 * @anchor Pitt2002
 * Pitt, M. K. Smooth particle filters for likelihood evaluation and
 * maximisation. Technical Report 651, Department of Economics, The University
 * of Warwick, <b>2002</b>.
 *
 * @anchor Pitt2011
 * Pitt, M. K.; Silva, R. S.; Giordani, P. & Kohn, R. Auxiliary particle
 * filtering within adaptive Metropolis-Hastings sampling, <b>2010</b>.
 * http://arxiv.org/abs/1006.1914
 *
 * @anchor Sarkka2008
 * Särkkä, S. Unscented Rauch-Tung-Striebel Smoother. <i>IEEE Transactions on
 * Automated Control</i>, <b>2008</b>, 53, 845-849.
 *
 * @anchor Silverman1986
 * Silverman, B.W. <i>Density Estimation for Statistics and Data
 * Analysis</i>. Chapman and Hall, <b>1986</b>.
 */
